/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module ascompose.c.functions;

import std.stdio;
import ascompose.c.types;
version (Windows)
	static immutable LIBRARY_ASCOMPOSE = ["compose-0.dll;compose.dll;compose.dll"];
else version (OSX)
	static immutable LIBRARY_ASCOMPOSE = ["compose.0.dylib"];
else
	static immutable LIBRARY_ASCOMPOSE = ["libappstream-compose.so.0"];

__gshared extern(C)
{

	// ascompose.Canvas

	GType asc_canvas_get_type();
	AscCanvas* asc_canvas_new(int width, int height);
	int asc_canvas_draw_text(AscCanvas* canvas, AscFont* font, const(char)* text, int borderWidth, int linePad, GError** err);
	int asc_canvas_draw_text_line(AscCanvas* canvas, AscFont* font, const(char)* text, int borderWidth, GError** err);
	uint asc_canvas_get_height(AscCanvas* canvas);
	uint asc_canvas_get_width(AscCanvas* canvas);
	int asc_canvas_render_svg(AscCanvas* canvas, GInputStream* stream, GError** err);
	int asc_canvas_save_png(AscCanvas* canvas, const(char)* fname, GError** err);

	// ascompose.Compose

	GType asc_compose_get_type();
	AscCompose* asc_compose_new();
	void asc_compose_add_allowed_cid(AscCompose* compose, const(char)* componentId);
	void asc_compose_add_unit(AscCompose* compose, AscUnit* unit);
	GPtrArray* asc_compose_fetch_components(AscCompose* compose);
	const(char)* asc_compose_get_data_result_dir(AscCompose* compose);
	AscComposeFlags asc_compose_get_flags(AscCompose* compose);
	AsFormatKind asc_compose_get_format(AscCompose* compose);
	const(char)* asc_compose_get_hints_result_dir(AscCompose* compose);
	const(char)* asc_compose_get_icons_result_dir(AscCompose* compose);
	const(char)* asc_compose_get_media_baseurl(AscCompose* compose);
	const(char)* asc_compose_get_media_result_dir(AscCompose* compose);
	const(char)* asc_compose_get_origin(AscCompose* compose);
	const(char)* asc_compose_get_prefix(AscCompose* compose);
	GPtrArray* asc_compose_get_results(AscCompose* compose);
	int asc_compose_has_errors(AscCompose* compose);
	void asc_compose_reset(AscCompose* compose);
	GPtrArray* asc_compose_run(AscCompose* compose, GCancellable* cancellable, GError** err);
	void asc_compose_set_data_result_dir(AscCompose* compose, const(char)* dir);
	void asc_compose_set_flags(AscCompose* compose, AscComposeFlags flags);
	void asc_compose_set_format(AscCompose* compose, AsFormatKind kind);
	void asc_compose_set_hints_result_dir(AscCompose* compose, const(char)* dir);
	void asc_compose_set_icons_result_dir(AscCompose* compose, const(char)* dir);
	void asc_compose_set_media_baseurl(AscCompose* compose, const(char)* url);
	void asc_compose_set_media_result_dir(AscCompose* compose, const(char)* dir);
	void asc_compose_set_origin(AscCompose* compose, const(char)* origin);
	void asc_compose_set_prefix(AscCompose* compose, const(char)* prefix);

	// ascompose.DirectoryUnit

	GType asc_directory_unit_get_type();
	AscDirectoryUnit* asc_directory_unit_new(const(char)* rootDir);
	const(char)* asc_directory_unit_get_root(AscDirectoryUnit* dirunit);
	void asc_directory_unit_set_root(AscDirectoryUnit* dirunit, const(char)* rootDir);

	// ascompose.Font

	GType asc_font_get_type();
	AscFont* asc_font_new_from_data(void* data, ptrdiff_t len, const(char)* fileBasename, GError** err);
	AscFont* asc_font_new_from_file(const(char)* fname, GError** err);
	void asc_font_add_language(AscFont* font, const(char)* lang);
	const(char)* asc_font_get_description(AscFont* font);
	const(char)* asc_font_get_family(AscFont* font);
	const(char)* asc_font_get_fullname(AscFont* font);
	const(char)* asc_font_get_homepage(AscFont* font);
	const(char)* asc_font_get_id(AscFont* font);
	GList* asc_font_get_language_list(AscFont* font);
	const(char)* asc_font_get_preferred_language(AscFont* font);
	const(char)* asc_font_get_sample_icon_text(AscFont* font);
	const(char)* asc_font_get_sample_text(AscFont* font);
	const(char)* asc_font_get_style(AscFont* font);
	void asc_font_set_preferred_language(AscFont* font, const(char)* lang);
	void asc_font_set_sample_icon_text(AscFont* font, const(char)* text);
	void asc_font_set_sample_text(AscFont* font, const(char)* text);

	// ascompose.Hint

	GType asc_hint_get_type();
	AscHint* asc_hint_new();
	AscHint* asc_hint_new_for_tag(const(char)* tag, GError** err);
	void asc_hint_add_explanation_var(AscHint* hint, const(char)* varName, const(char)* text);
	char* asc_hint_format_explanation(AscHint* hint);
	const(char)* asc_hint_get_explanation_template(AscHint* hint);
	GPtrArray* asc_hint_get_explanation_vars_list(AscHint* hint);
	AsIssueSeverity asc_hint_get_severity(AscHint* hint);
	const(char)* asc_hint_get_tag(AscHint* hint);
	int asc_hint_is_error(AscHint* hint);
	int asc_hint_is_valid(AscHint* hint);
	void asc_hint_set_explanation_template(AscHint* hint, const(char)* explanationTmpl);
	void asc_hint_set_severity(AscHint* hint, AsIssueSeverity severity);
	void asc_hint_set_tag(AscHint* hint, const(char)* tag);

	// ascompose.Image

	GType asc_image_get_type();
	AscImage* asc_image_new();
	AscImage* asc_image_new_from_data(void* data, ptrdiff_t len, uint destSize, int compressed, AscImageLoadFlags flags, GError** err);
	AscImage* asc_image_new_from_file(const(char)* fname, uint destSize, AscImageLoadFlags flags, GError** err);
	GHashTable* asc_image_supported_format_names();
	uint asc_image_get_height(AscImage* image);
	GdkPixbuf* asc_image_get_pixbuf(AscImage* image);
	uint asc_image_get_width(AscImage* image);
	int asc_image_load_filename(AscImage* image, const(char)* filename, uint destSize, uint srcSizeMin, AscImageLoadFlags flags, GError** err);
	int asc_image_save_filename(AscImage* image, const(char)* filename, uint width, uint height, AscImageSaveFlags flags, GError** err);
	GdkPixbuf* asc_image_save_pixbuf(AscImage* image, uint width, uint height, AscImageSaveFlags flags);
	void asc_image_scale(AscImage* image, uint newWidth, uint newHeight);
	void asc_image_scale_to_fit(AscImage* image, uint size);
	void asc_image_scale_to_height(AscImage* image, uint newHeight);
	void asc_image_scale_to_width(AscImage* image, uint newWidth);
	void asc_image_set_pixbuf(AscImage* image, GdkPixbuf* pixbuf);

	// ascompose.Result

	GType asc_result_get_type();
	AscResult* asc_result_new();
	int asc_result_add_component(AscResult* result, AsComponent* cpt, GBytes* bytes, GError** err);
	int asc_result_add_component_with_string(AscResult* result, AsComponent* cpt, const(char)* data, GError** err);
	int asc_result_add_hint(AscResult* result, AsComponent* cpt, const(char)* tag, const(char)* key1, ... );
	int asc_result_add_hint_by_cid(AscResult* result, const(char)* componentId, const(char)* tag, const(char)* key1, ... );
	int asc_result_add_hint_simple(AscResult* result, AsComponent* cpt, const(char)* tag);
	uint asc_result_components_count(AscResult* result);
	GPtrArray* asc_result_fetch_components(AscResult* result);
	GPtrArray* asc_result_fetch_hints_all(AscResult* result);
	const(char)* asc_result_gcid_for_cid(AscResult* result, const(char)* cid);
	const(char)* asc_result_gcid_for_component(AscResult* result, AsComponent* cpt);
	const(char)* asc_result_get_bundle_id(AscResult* result);
	AsBundleKind asc_result_get_bundle_kind(AscResult* result);
	AsComponent* asc_result_get_component(AscResult* result, const(char)* cid);
	char** asc_result_get_component_gcids(AscResult* result);
	char** asc_result_get_component_ids_with_hints(AscResult* result);
	GPtrArray* asc_result_get_hints(AscResult* result, const(char)* cid);
	uint asc_result_hints_count(AscResult* result);
	int asc_result_remove_component(AscResult* result, AsComponent* cpt);
	int asc_result_remove_component_by_id(AscResult* result, const(char)* cid);
	void asc_result_remove_hints_for_cid(AscResult* result, const(char)* cid);
	void asc_result_set_bundle_id(AscResult* result, const(char)* id);
	void asc_result_set_bundle_kind(AscResult* result, AsBundleKind kind);
	int asc_result_unit_ignored(AscResult* result);
	int asc_result_update_component_gcid(AscResult* result, AsComponent* cpt, GBytes* bytes);
	int asc_result_update_component_gcid_with_string(AscResult* result, AsComponent* cpt, const(char)* data);
	int asc_result_add_hint_v(AscResult* result, AsComponent* cpt, const(char)* tag, char** kv);
	int asc_result_add_hint_by_cid_v(AscResult* result, const(char)* componentId, const(char)* tag, char** kv);

	// ascompose.Unit

	GType asc_unit_get_type();
	AscUnit* asc_unit_new();
	void asc_unit_add_relevant_path(AscUnit* unit, const(char)* path);
	void asc_unit_close(AscUnit* unit);
	int asc_unit_dir_exists(AscUnit* unit, const(char)* dirname);
	int asc_unit_file_exists(AscUnit* unit, const(char)* filename);
	const(char)* asc_unit_get_bundle_id(AscUnit* unit);
	AsBundleKind asc_unit_get_bundle_kind(AscUnit* unit);
	GPtrArray* asc_unit_get_contents(AscUnit* unit);
	GPtrArray* asc_unit_get_relevant_paths(AscUnit* unit);
	void* asc_unit_get_user_data(AscUnit* unit);
	int asc_unit_open(AscUnit* unit, GError** err);
	GBytes* asc_unit_read_data(AscUnit* unit, const(char)* filename, GError** err);
	void asc_unit_set_bundle_id(AscUnit* unit, const(char)* id);
	void asc_unit_set_bundle_kind(AscUnit* unit, AsBundleKind kind);
	void asc_unit_set_contents(AscUnit* unit, GPtrArray* contents);
	void asc_unit_set_user_data(AscUnit* unit, void* userData);

	// ascompose.Utils

	AscImageFormat asc_image_format_from_filename(const(char)* fname);

	// ascompose.Globals

	const(char)* asc_globals_get_tmp_dir();
	const(char)* asc_globals_get_tmp_dir_create();
	void asc_globals_set_tmp_dir(const(char)* path);
	int asc_globals_get_use_optipng();
	void asc_globals_set_use_optipng(int enabled);
	const(char)* asc_globals_get_optipng_binary();
	void asc_globals_set_optipng_binary(const(char)* path);
	int asc_globals_add_hint_tag(const(char)* tag, AsIssueSeverity severity, const(char)* explanation, int overrideExisting);
	char** asc_globals_get_hint_tags();
	AsIssueSeverity asc_globals_hint_tag_severity(const(char)* tag);
	const(char)* asc_globals_hint_tag_explanation(const(char)* tag);

	// ascompose.MetaInfoUtils

	AsComponent* asc_parse_metainfo_data(AscResult* cres, AsMetadata* mdata, GBytes* bytes, const(char)* miBasename);
	AsComponent* asc_parse_metainfo_data_simple(AscResult* cres, GBytes* bytes, const(char)* miBasename);
	void asc_validate_metainfo_data_for_component(AscResult* cres, AsValidator* validator, AsComponent* cpt, GBytes* bytes, const(char)* miBasename);
	AsComponent* asc_parse_desktop_entry_data(AscResult* cres, AsComponent* cpt, GBytes* bytes, const(char)* deBasename, int ignoreNodisplay, AsFormatVersion fversion, AscTranslateDesktopTextFn deL10nFn, void* userData);

	// ascompose.TranslationUtils

	void asc_read_translation_status(AscResult* cres, AscUnit* unit, const(char)* prefix, uint minPercentage);
}